<?php
if(is_admin()){
    include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
}
class WC_AM_Gabon  extends WC_Payment_Gateway
{
    private $am_page_title = "Airtel Money Redirection";

    public function __construct() {

        // called after all plugins have loaded
        $this->init_form_fields();
        $this->templates =  wp_get_theme()->get_page_templates();
        if ( empty( $this->templates ) ) {
            $this->templates = array();
        }
    
    $this->order_button_text='Payer ';
    $this->id = "wc_am_gabon";
    $this->icon = plugins_url()."/woocommerce-airtelmoney-gabon/images/airtel-money.png";
    $this->has_fields = false;
    $this->method_title = __("Airtel Money Gabon", 'wc_airtelmoney_gabon');
    $this->method_description = __("Airtel Money Gabon payment gatway for woocommerce", 'wc_airtelmoney_gabon');
    $this->view_transaction_url = 'https://mypvitapi.pro/api/pvit-secure-full-api-v3.kk';
    $this->title = __("Airtel Money Gabon", 'wc_airtelmoney_gabon');
    $this->redirect_page_id = '';
    $this -> liveurl = "https://mypvitapi.pro/api/pvit-secure-full-api-v3.kk";

    // add_action('init', array($this, 'check_am_response'));
    add_filter('wc-am-get-telmarchand','get_telmarchand');
        if ( is_admin() ) {

            // Versions over 2.0
            // Save our administration options. Since we are not going to be doing anything special
            // we have not defined 'process_admin_options' in this class so the method in the parent
            // class will be used instead
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
        }
        $this->init_settings();

        // Turn these settings into variables we can use
        foreach ( $this->settings as $setting_key => $value ) {
            $this->$setting_key = $value;
        }
        add_action( 'woocommerce_api_'.$this->id, array( $this , 'run_pvit_callback' ) );


        // Add a filter to the attributes metabox to inject template into the cache.
        if ( version_compare( floatval( get_bloginfo( 'version' ) ), '4.7', '<' ) ) {

            // 4.6 and older
            add_filter(
                'page_attributes_dropdown_pages_args',
                array( $this, 'register_project_templates' )
            );

        } else {

            // Add a filter to the wp 4.7 version attributes metabox
            add_filter(
                'theme_page_templates', array( $this, 'add_new_template' )
            );

        }

        // Add a filter to the save post to inject out template into the page cache
        add_filter(
            'wp_insert_post_data', 
            array( $this, 'register_project_templates' ) 
        );

        // Add a filter to the template include to determine if the page has our 
        // template assigned and return it's path
        add_filter(
            'template_include', 
            array( $this, 'view_project_template') 
        );

        // Add your templates to this array.
        $this->templates = array(
            'Airtel.php' => 'Airtel',
        );



    }

/**
 * Init setting form fields
 * 
 */
    public function get_telmarchand(){
        return $this->settings["tel_marchand"];

    }
     public function init_form_fields()
     {
        $this->form_fields = apply_filters( 'wc_offline_form_fields', array(
          
            'enabled' => array(
                'title'   => 'Activer/Desactiver',
                'type'    => 'checkbox',
                'label'   => 'Activer le paiement par Airtel Money',
                'default' => 'yes'
            ),
    
            'title' => array(
                'title'       =>  'Titre',
                'type'        => 'text',
                'description' => 'Ce champ control le titre appercu par le client pendant le paiement.',
                'default'     => get_option("title"),
                'desc_tip'    => true,
            ),
    
            'description' => array(
                'title'       => 'Description',
                'type'        => 'textarea',
                'description' => 'Paiement en ligne via Airtel Money.',
                'default'     => __('Payer facilement en ligne via Airtel Money.','wc-airtelmoney-gabon'),
                'desc_tip'    => true,
            ),
    
            'tel_marchand' => array(
                'title'       => 'Numero de telephone marchand',
                'type'        => 'text',
                'description' => 'Numero Airtel utilise pour creer le compte marchand',
                'desc_tip'    => true,
            ) ,
                'url_redirect' => array(
                'title'       => 'Url de redirection',
                'type'        => 'text',
                'description' => 'Url vers laquelle le client est redirigé ',
                'default'     => '',
                'desc_tip'    => true
            )
        ) );
     }


     public function init_settings()
     {

         parent::init_settings(); // TODO: Change the autogenerated stub

     }
    public function process_payment( $order_id )
    {
        $order = wc_get_order( $order_id );

//     // Mark as on-hold (we're awaiting the payment)
        $order->update_status( 'on-hold', __( 'Awaiting offline payment', 'wc-gateway-offline' ) );

        // Save order
        $order->save();

        $order = wc_get_order($order_id);
        $order->reduce_order_stock();
        wc_reduce_stock_levels($order);

        $page = get_page_by_title( $this->mc_page_title, OBJECT, 'page' );
        $page_id = null == $page ? -1 : $page->ID;
        $url_redirect = add_query_arg( array(
            'refer' => $order->get_id(),
            'mnt' => $order->get_total(),
            'telm'=> $this->get_telmarchand(),
            'redir'=> urlencode(get_home_url())
        ), get_page_link($page_id));

        // Redirect to thank you page
        return array(
            'result' => 'success',
            'redirect' => $url_redirect
        );
    }



    public function run_pvit_callback() {

        $data_received=file_get_contents("php://input");
        $data_received_xml=new SimpleXMLElement($data_received);
        $ligne_response=$data_received_xml[0];
        $reference_received=$ligne_response->REF; // Rér&rence de la transaction == ID de la commande
        $statut_received=$ligne_response->STATUT; // Statut final de la transaction
        $client_received=$ligne_response->TEL_CLIENT; // Numéro client ayant effectué le paiement 
        $message_received=$ligne_response->MESSAGE; 

        $order = wc_get_order(intval($reference_received));

       // var_dump($order);
        if ( $order && $order->get_status() == 'on-hold') {
            echo ('inside');
            if ( 200 == $statut_received) {
                echo ('200:Success');
                $order->payment_complete();
                // Payment has been successful
                //$order->add_order_note(__('Airtel Money payment completed.', 'wc-airtelmoney-gabon'));
    
            } else {
                print_r('400:Failed');
                $order->cancel_order();
                wc_add_notice( __('Payment error:', 'woothemes') . $error_message, 'error' );
                $order->add_order_note(__('Airtel Money payment failed.', 'wc-airtelmoney-gabon'));
                return;
            }
        } else {
            print_r('404:Order not found');
        }
        
        exit();
    }




    public function add_new_template( $posts_templates ) {
        $posts_templates = array_merge( $posts_templates, $this->templates );
        return $posts_templates;
    }

    /**
     * Adds our template to the pages cache in order to trick WordPress
     * into thinking the template file exists where it doens't really exist.
     */
    public function register_project_templates( $atts ) {

        // Create the key used for the themes cache
        $cache_key = 'page_templates-' . md5( get_theme_root() . '/' . get_stylesheet() );

        // Retrieve the cache list.
        // If it doesn't exist, or it's empty prepare an array
        $templates = wp_get_theme()->get_page_templates();
        if ( empty( $templates ) ) {
            $templates = array();
        }

        // New cache, therefore remove the old one
        wp_cache_delete( $cache_key , 'themes');

        // Now add our template to the list of templates by merging our templates
        // with the existing templates array from the cache.
        $templates = array_merge( $templates, $this->templates );

        // Add the modified cache to allow WordPress to pick it up for listing
        // available templates
        wp_cache_add( $cache_key, $templates, 'themes', 1800 );

        return $atts;

    }

    /**
     * Checks if the template is assigned to the page
     */
    public function view_project_template( $template ) {
        // Return the search template if we're searching (instead of the template for the first result)
        if ( is_search() ) {
            return $template;
        }

        // Get global post
        global $post;

        // Return template if post is empty
        if ( ! $post ) {
            return $template;
        }

        // Return default template if we don't have a custom one defined
        if ( ! isset( $this->templates[get_post_meta(
            $post->ID, '_wp_page_template', true
        )] ) ) {
            return $template;
        }

        // Allows filtering of file path
        $filepath = apply_filters( 'page_templater_plugin_dir_path', plugin_dir_path( __FILE__ ) );

        $file =  $filepath . get_post_meta(
            $post->ID, '_wp_page_template', true
        );

        // Just to be safe, we check if the file exist first
        if ( file_exists( $file ) ) {
            return $file;
        } else {
            echo $file;
        }

        // Return template
        return $template;

    }


}


// finally instantiate our plugin class and add it to the set of globals

$GLOBALS['wc_am_gabon'] = new WC_AM_Gabon();
